package com.app.ui.activity

import android.Manifest
import android.content.Intent
import android.graphics.BitmapFactory
import android.graphics.Color
import android.graphics.Rect
import android.os.Bundle
import android.support.v4.content.res.ResourcesCompat
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.SpannableStringBuilder
import android.text.Spanned.SPAN_EXCLUSIVE_EXCLUSIVE
import android.text.TextUtils
import android.text.style.AbsoluteSizeSpan
import android.text.style.ForegroundColorSpan
import android.util.Log
import android.view.View
import android.widget.ImageView
import android.widget.ZoomControls
import com.app.R
import com.app.YYApplication
import com.app.api.InterfaceUrlConstants
import com.app.api.RequestApiData
import com.app.business.YYDataPool
import com.app.constants.Constants
import com.app.constants.KeyConstants
import com.app.constants.RazorConstants
import com.app.constants.ViewFromConstants
import com.app.event.UpdateEnterSceceBtnEvent
import com.app.model.*
import com.app.model.request.*
import com.app.model.response.*
import com.app.ui.MediaPlayerActivity
import com.app.ui.adapter.MessageChatAdapter
import com.app.ui.adapter.SpacePhotoListAdapter
import com.app.ui.fragment.MessageQaFragment
import com.app.ui.fragment.OnLinePersonFragment
import com.app.ui.fragment.OnLineVoiceFragment
import com.app.ui.fragment.YuanFenNewUiTabFragment
import com.app.util.EventBusHelper
import com.app.util.Tools
import com.app.util.cache.YYPreferences
import com.app.util.map.LocationUtil
import com.app.widget.dialog.CustomDialog
import com.app.widget.dialog.SceneSelectionDialog
import com.app.widget.viewflow.Layout58
import com.baidu.location.BDLocation
import com.baidu.mapapi.map.*
import com.baidu.mapapi.model.LatLng
import com.sp.util.YYPreferenceSP
import com.wbtech.ums.UmsAgent
import com.yanzhenjie.permission.Action
import com.yanzhenjie.permission.AndPermission
import com.yy.BaseApplication
import com.yy.rationale.RuntimeRationale
import com.yy.ui.BaseActivity
import com.yy.util.LogUtils
import com.yy.util.SystemBarTintManager
import com.yy.util.file.FileUtils
import com.yy.util.image.VolleyUtil
import com.yy.util.net.NewHttpResponeCallBack
import com.yy.util.string.StringUtils
import com.yy.widget.InsertPictureDialog
import kotlinx.android.synthetic.main.individuality_space_layout.*
import java.io.File
import java.io.FileInputStream
import java.io.InputStream
import java.util.*

class IndividualitySpaceActivity : MediaPlayerActivity(), NewHttpResponeCallBack {

    private val permissions = arrayOf(Manifest.permission.ACCESS_COARSE_LOCATION, Manifest.permission.ACCESS_FINE_LOCATION)

    private fun setMapLocation() {

        try {

            val lat = mapLocation?.lat
            val lng = mapLocation?.lng
            val location = LatLng(lat!!, lng!!)

            val locData = MyLocationData.Builder()
                    .accuracy(50f)
                    // 此处设置开发者获取到的方向信息，顺时针0-360
                    .direction(100f).latitude(location.latitude)
                    .longitude(location.longitude).build()
            mBaiduMap?.setMyLocationData(locData)

            val u = MapStatusUpdateFactory.newLatLng(location)
            mBaiduMap?.animateMapStatus(u)
            mBaiduMap?.setMapStatus(u)


            //定义Maker坐标点
            val bitmap = BitmapDescriptorFactory.fromResource(R.drawable.location_icon)
            val option = MarkerOptions()
                    .position(location)
                    .icon(bitmap)
            mBaiduMap?.addOverlay(option)

        } catch (e: Exception) {
            LogUtils.w("Test", e.toString())
        }

    }

    private var adverts: List<Advert>? = null
    private var mapLocation: MapLocation? = null
    private var postion: Int = 0
    private var oppositeText: String = "真心恋爱"
    private var mUser: User? = null
    private var pool: YYDataPool? = null
    private var mFrom: String? = null
    private val defaultLeftBitmap = BitmapFactory.decodeResource(
            YYApplication.getInstance().resources,
            if (Tools.isBoy()) R.drawable.female_user_default_icon else R.drawable.male_user_default_icon)

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.individuality_space_layout)
        initData()
    }

    override fun immerseStatusBar() {
    }

    private fun initData() {
        val layoutParams = id_space_top_bg.layoutParams
        // 设置沉浸式状态栏
        val isSupport = SystemBarTintManager.setStatusBarTintMode(window, false, Color.TRANSPARENT)
        if (isSupport) {
            val statusBarHeight = SystemBarTintManager.getStatusBarHeight(this);
            id_space_top_bg.setPadding(id_space_top_bg.paddingLeft, statusBarHeight, id_space_top_bg.paddingRight, id_space_top_bg.paddingBottom)
            layoutParams.height = Tools.dp2px(178f) + statusBarHeight
        } else {
            layoutParams.height = Tools.dp2px(178f)
        }
        id_space_top_bg.layoutParams = layoutParams



        postion = intent.getIntExtra(KeyConstants.KEY_POSITION, 0)
        mFrom = intent.getStringExtra(KeyConstants.KEY_FROM)
        if (OnLineVoiceFragment::class.java.simpleName == mFrom) {
            id_space_date.text = "和她语聊"
            id_space_date.setOnClickListener {
                videoInvitation(mUser as UserBase, SponsorVideoRequest.SRC_RECOMMENT_VOICE_CHAT)
            }
            oppositeText = "在线语音"

        } else if (OnLinePersonFragment::class.java.simpleName == mFrom || YuanFenNewUiTabFragment::class.java.simpleName == mFrom) {
            id_space_date.text = "打个招呼"
            id_space_date.setOnClickListener {
                sayHello()
            }

        } else if (MessageChatAdapter::class.java.simpleName == mFrom || ViewFromConstants.FROM_MSG_QA == mFrom) {

            if (!Tools.isPay2()) {
                reply_ask_contact_tv.visibility = View.VISIBLE
                reply_ask_contact_tv.setOnClickListener {


                    var payUrl = intent.getStringExtra(KeyConstants.KEY_URL)
                    if (StringUtils.isEmpty(payUrl)) {
                        val configInfoResponse = YYApplication
                                .getInstance().configInfo
                        if (configInfoResponse != null
                                && configInfoResponse.payUrlCfg != null
                                && !TextUtils.isEmpty(configInfoResponse.payUrlCfg.simpleInfoUrl)) {
                            payUrl = configInfoResponse.payUrlCfg.buyMonthlyUrl
                        }
                    }
                    if (!StringUtils.isEmpty(payUrl)) {
                        val intent = Intent(mContext, WebViewActivity::class.java)
                        intent.putExtra(KeyConstants.KEY_URL, payUrl)
                        intent.putExtra(KeyConstants.KEY_TITLE, "购买服务")
                        intent.putExtra("sourceURL", "noFeeMessage")
                        startActivity(intent)
                    }
                }
            }

        } /*else if (YuanFenNewUiTabFragment::class.java.simpleName == mFrom) {
            oppositeText = "在线约会"
            id_space_date.text = if (Tools.isBoy()) "约她" else "约他"
            id_space_date.setOnClickListener {
                singleOutUser(1)
            }
        }*/

        var userId: String? = null
        val serializableExtra = intent.getSerializableExtra(KeyConstants.KEY_USER)
        if (serializableExtra is User?) {
            mUser = serializableExtra
            userId = mUser?.id
        } else if (serializableExtra is UserBase) {
            userId = serializableExtra.id
        }



        pool = YYDataPool.getInstance(YYApplication.getInstance())
        RequestApiData.getInstance().userInfo(UserInfoRequest(userId, 0, 0), UserInfoResponse::class.java, this)
    }

    private fun sayHello() {
        RequestApiData.getInstance().sayHello(SayHelloRequest(mUser?.id, 3), SayHelloResponse::class.java, this)
    }

    private fun initView() {

        id_space_date.visibility = if (!mUser!!.isSayHello && MessageChatAdapter::class.java.simpleName != mFrom && ViewFromConstants.FROM_MSG_QA != mFrom) View.VISIBLE else View.GONE

        id_space_top_bg.background = resources.getDrawable(if (Tools.isBoy()) R.drawable.space_top_woman_bg else R.drawable.space_top_man_bg)
        id_space_back.setOnClickListener {
            finish()
        }
        id_space_name.text = mUser?.nickName

        id_space_age.text = if (mUser!!.age > 0) {
            id_space_age.visibility = View.VISIBLE
            StringBuffer().append(mUser?.age).append("岁")
        } else {
            id_space_age.visibility = View.GONE
            ""
        }
        id_space_age.background = if (Tools.isBoy()) ResourcesCompat.getDrawable(resources, R.drawable.space_woman_age_shape, null) else ResourcesCompat.getDrawable(resources, R.drawable.space_man_age_shape, null)

        val heightWightText = StringBuffer()
        if (!StringUtils.isEmpty(mUser?.height)) {
            heightWightText.append(mUser?.height).append("cm")
        }

        if (!StringUtils.isEmpty(mUser?.weight) && mUser?.weight?.toInt()!! > 0) {
            heightWightText.append("/").append((Integer.valueOf(mUser?.weight) / 2)).append("kg")
            id_space_height_weight.text = heightWightText

        } else {
            id_space_height_weight.visibility = View.GONE
        }
        val income = pool?.getKvsName(pool?.shouru, mUser?.income)
        id_space_income.visibility = if (StringUtils.isEmpty(income)) {
            View.GONE
        } else {
            id_space_income.text = income
            View.VISIBLE
        }

        val mImage = mUser?.image
        if (mImage != null) {
            val imageUrl = mImage.imageUrl
            if (!StringUtils.isEmpty(imageUrl)) {
                YYApplication.getInstance().imageLoader.get(imageUrl,
                        VolleyUtil.getImageListener(id_space_photo, defaultLeftBitmap, defaultLeftBitmap),
                        id_space_photo.measuredWidth, id_space_photo.measuredHeight, true)
            }
        }
        run {

            val frontText = if (Tools.isBoy()) "她希望能跟人 " else "他希望能跟人 "
            val oppositeStringBuilder = SpannableStringBuilder()
            oppositeStringBuilder.append(frontText).append(" ").append(oppositeText)
            val foregroundColorSpan = ForegroundColorSpan(Color.parseColor("#FF4083"))
            val absoluteSizeSpan = AbsoluteSizeSpan(16, true)
            oppositeStringBuilder.setSpan(absoluteSizeSpan, frontText.length, oppositeStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE);
            oppositeStringBuilder.setSpan(foregroundColorSpan, frontText.length, oppositeStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
            id_space_opposite.text = oppositeStringBuilder

        }

        if (!StringUtils.isEmpty(mUser?.oppositeType)) {
            val frontText = if (Tools.isBoy()) "喜欢男生类型 " else "喜欢女生类型 "
            val individualityStringBuilder = SpannableStringBuilder()
            individualityStringBuilder.append(frontText).append(" ").append(mUser?.oppositeType)
            val foregroundColorSpan = ForegroundColorSpan(Color.parseColor(if (Tools.isBoy()) "#055CDF" else "#FF8A18"))
            val absoluteSizeSpan = AbsoluteSizeSpan(16, true)
            individualityStringBuilder.setSpan(absoluteSizeSpan, frontText.length, individualityStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
            individualityStringBuilder.setSpan(foregroundColorSpan, frontText.length, individualityStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
            id_space_individuality.text = individualityStringBuilder
        }

        val matchDegree = mUser?.matchDegree
        if (matchDegree != null) {
            if (matchDegree > 0) {
                val matchDegreeStringBuilder = SpannableStringBuilder()
                val frontText = "匹配度\n"
                matchDegreeStringBuilder.append(frontText).append(matchDegree.toString()).append("%")
                val absoluteSizeSpan = AbsoluteSizeSpan(16, true)
                matchDegreeStringBuilder.setSpan(absoluteSizeSpan, frontText.length, matchDegreeStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
                id_space_match_number.text = matchDegreeStringBuilder
                id_space_match_number.background = ResourcesCompat.getDrawable(resources, if (Tools.isBoy()) R.drawable.space_match_number_woman_shape else R.drawable.space_match_number_man_shape, null)
            }
        }


        val size = mUser?.listImage?.size

        val isShow = if (size != null) {
            if (size > 0) {
                id_space_photo_title.text = String.format(resources.getString(R.string.space_photo_title_txt), size.toString())
                id_space_photo_list.layoutManager = LinearLayoutManager(YYApplication.getInstance(), LinearLayoutManager.HORIZONTAL, false)
                val spacePhotoListAdapter = SpacePhotoListAdapter()
                spacePhotoListAdapter.setData(mUser!!.listImage)
                spacePhotoListAdapter.notifyDataSetChanged()
                id_space_photo_list.adapter = spacePhotoListAdapter
                id_space_photo_list.addItemDecoration(object : RecyclerView.ItemDecoration() {
                    override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State?) {
                        super.getItemOffsets(outRect, view, parent, state)
                        val childPosition = parent.getChildPosition(view)

                        if (childPosition > 0) {
                            outRect.left = Tools.dp2px(5f)
                        }
                    }
                })

                spacePhotoListAdapter.setOnItemListener { view, position ->

                    val intent = Intent(YYApplication.getInstance(), ImagePreviewActivity::class.java)
                    run {
                        // 设置界面切换动画
                        intent.putExtra(BaseActivity.EXTRA_OPEN_ANIM_IN, R.anim.zoom_enter)
                        intent.putExtra(BaseActivity.EXTRA_CLOSE_ANIM_OUT, R.anim.zoom_exit)
                    }
                    intent.putExtra(KeyConstants.KEY_LISTIMAGE, mUser?.listImage as ArrayList<Image>)
                    intent.putExtra(KeyConstants.KEY_IMAGEPOSITION, position)
                    startActivity(intent)
                }

                true
            } else {
                false
            }
        } else {
            false
        }
        id_space_photo_title.visibility = if (isShow) View.VISIBLE else View.GONE
        id_space_photo_list.visibility = if (isShow) View.VISIBLE else View.GONE


        if (mUser?.isVerifyMobile == 1) {
            val numberStringBuilder = SpannableStringBuilder("手机号已验证")
            val foregroundColorSpan = ForegroundColorSpan(Color.BLACK)
            numberStringBuilder.setSpan(foregroundColorSpan, 0, numberStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
            id_space_phone_number.text = numberStringBuilder
            id_space_phone_number.setCompoundDrawablesWithIntrinsicBounds(R.drawable.space_safety_foucsed_icon, 0, 0, 0)
        }

        if (mUser?.isVerifyIdentity == 1) {
            val identityStringBuilder = SpannableStringBuilder("身份已验证")
            val foregroundColorSpan = ForegroundColorSpan(Color.BLACK)
            identityStringBuilder.setSpan(foregroundColorSpan, 0, identityStringBuilder.length, SPAN_EXCLUSIVE_EXCLUSIVE)
            id_space_identity_number.text = identityStringBuilder
            id_space_identity_number.setCompoundDrawablesWithIntrinsicBounds(R.drawable.space_safety_foucsed_icon, 0, 0, 0)
        }

        id_space_date.background = ResourcesCompat.getDrawable(resources, if (Tools.isBoy()) R.drawable.space_date_woman_bg else R.drawable.space_date_man_bg, null)

        if (Tools.isBoy()) {
            //语音豆复购弹窗
            showVoiceBeanPay()
        }

        if (mapLocation != null && Tools.isBoy()) {

            if (AndPermission.hasPermissions(this@IndividualitySpaceActivity, permissions)) {
                // 有对应的权限
                initMap()
            } else {
                // 没有对应的权限
                id_space_map.visibility = View.GONE
                requestPermission(*permissions)
            }
        }
        memberAd.setOnItemClickListener(Layout58.OnItemClickListener<Advert> { advert, view ->
            Advert.Tool.execAdvert(advert, this@IndividualitySpaceActivity)
        })
        memberAd.bindItems(adverts)

    }


    /**
     * 邀请
     * @param userBase
     */
    fun videoInvitation(userBase: UserBase, src: Int) {
        if (YYPreferences.getInstance().getBoolean(YYPreferences.TAG_DEFAUT_SETTING, false) || src == SponsorVideoRequest.SRC_RECOMMENT_VOICE_CHAT) {// 读取默认设置状态
            var isShowFace = false
            val configInfo = YYApplication.getInstance().configInfo
            if (configInfo != null) {
                val otherCfg = configInfo.otherCfg
                if (otherCfg != null) {
                    if (otherCfg.isLeakingFacee == 1) {
                        isShowFace = true
                    }
                }
            }
            loadVideoPlugin(isShowFace, userBase, src)
        } else if (fragmentManager != null) {
            val dialog = SceneSelectionDialog().newInstance()
            dialog.show(supportFragmentManager, "dialog")
            dialog.setOnFinishListener { isShowFace, isDefautItme ->
                val configInfo = YYApplication.getInstance().configInfo
                if (configInfo != null) {
                    val otherCfg = configInfo.otherCfg
                    if (otherCfg != null) {
                        otherCfg.isLeakingFacee = if (isShowFace) 1 else 0
                        configInfo.otherCfg = otherCfg
                    }
                }
                YYPreferences.getInstance().putBoolean(YYPreferences.TAG_DEFAUT_SETTING, isDefautItme)
                loadVideoPlugin(isShowFace, userBase, src)
            }
        }
    }

    /**
     * 加载插件
     * @param isShowFace 是否露脸
     * *
     * @param userBase
     */
    private fun loadVideoPlugin(isShowFace: Boolean, userBase: UserBase?, src: Int) {

        if (userBase == null) {
            return
        }

        val type = if (!Tools.isAvailable(YYApplication.getInstance(), YYApplication.getInstance().VIDEO_APP_PACKAGE_NAME)) 1 else 0
        val request = SponsorVideoRequest(userBase.id, YYPreferences.getInstance().userId, if (isShowFace) 1 else 0, src, type)
        RequestApiData.getInstance().sponsorVideo(request, SponsorVideoResponse::class.java, object : NewHttpResponeCallBack {
            override fun onResponeStart(apiName: String) {
                if (InterfaceUrlConstants.URL_SPONSORVIDEO == apiName) {
                    showLoadingDialog("正在邀请...")
                }
            }

            override fun onLoading(apiName: String, count: Long, current: Long) {

            }

            override fun onSuccess(apiName: String, `object`: Any) {
                if (InterfaceUrlConstants.URL_SPONSORVIDEO == apiName) {
                    if (`object` is SponsorVideoResponse) {
                        val response = `object`
                        val state = response.state
                        YYPreferenceSP.getInstance().putInt(KeyConstants.KEY_VIDEO_STATE, state)
                        if (state == 0 || state == 5) {// 可以连通
                            val usableTime = response.usableTime
                            val videoId = response.videoId
                            val noPwdState = response.noPwdState
                            val continueBuyUrl = response.continueBuyUrl
                            YYPreferenceSP.getInstance().putInt(KeyConstants.KEY_VIDEO_ID, videoId)

                            val url = response.url
                            YYPreferenceSP.getInstance().putString(KeyConstants.KEY_VIDEO_STATE_URL, if (state == 5) url else "")

                            if (userBase != null) {
                                val image = userBase.image
                                var imgUrl = ""
                                if (image != null) {
                                    imgUrl = image.imageUrl
                                }
                                YYApplication.getInstance().startVideoApp(
                                        YYPreferences.getInstance().userId,
                                        userBase.id,
                                        userBase.nickName,
                                        imgUrl,
                                        YYPreferences.getInstance().gender,
                                        usableTime,
                                        isShowFace,
                                        0, 0, noPwdState, continueBuyUrl,
                                        supportFragmentManager)

                            }
                        } else if (state == 6) {
                            val usableTime = response.usableTime
                            val noPwdState = response.noPwdState
                            val continueBuyUrl = response.continueBuyUrl
                            val videoId = response.videoId
                            YYPreferenceSP.getInstance().putInt(KeyConstants.KEY_VIDEO_ID, videoId)

                            if (userBase != null) {
                                val image = userBase.image
                                var imgUrl = ""
                                if (image != null) {
                                    imgUrl = image.imageUrl
                                }
                                YYApplication.getInstance().startVoiceApp(
                                        YYPreferences.getInstance().userId,
                                        userBase.id,
                                        userBase.nickName,
                                        imgUrl,
                                        YYPreferences.getInstance().gender,
                                        usableTime,
                                        0,
                                        noPwdState,
                                        continueBuyUrl,
                                        supportFragmentManager
                                )
                            }

                        } else if (state == 1) {// 跳付费页面
                            val url = response.url
                            showWebViewActivity(url, "会员服务")
                        } else if (state == 2) {// 占线
                            val msg = response.msg
                            Tools.showToast(msg, 3000)
                        } else if (state == 3) {// 占线
                            val msg = response.msg
                            Tools.showToast(msg, 3000)
                        }

                        if (state != 1) {
                            dismissLoadingDialog()
                        }
                    }
                }
            }

            override fun onFailure(apiName: String, t: Throwable?, errorNo: Int, strMsg: String?) {
                Tools.showToast(strMsg)
                dismissLoadingDialog()
            }
        })
    }


    override fun onDestroy() {
        super.onDestroy()
    }


    override fun onResponeStart(apiName: String?) {
        showLoadingDialog("加载中...")

    }

    override fun onLoading(apiName: String?, count: Long, current: Long) {
    }

    override fun onSuccess(apiName: String?, `object`: Any?) {
        dismissLoadingDialog()
        if (InterfaceUrlConstants.URL_USERINFO.equals(apiName)) {
            if (`object` is UserInfoResponse) {
                mUser = `object`.user
                mapLocation = `object`.mapLocation
                adverts = `object`.advertViewList
                initView()
            }
        } else if (InterfaceUrlConstants.URL_SAYHELLO == apiName) {
            // 打招呼
            if (`object` is SayHelloResponse) {

                if (`object`.isSucceed == 1) {
                    changeState()
                }

                Tools.showToast(`object`.msg)
            }
        } else if (InterfaceUrlConstants.URL_IS_HAVE_AGENCY == apiName) {
            if (`object` is IsHaveAgencyResponse) {
                if (`object`.status == 1) {
                    //判断该签约用户是否购买服务
                    imSignIcon?.visibility = View.GONE
                } else {
                    //用户未签约
                    showUnsignedIcon()
                }
            }
        }
    }

    override fun onFailure(apiName: String?, t: Throwable?, errorNo: Int, strMsg: String?) {
        dismissLoadingDialog()
        if (!StringUtils.isEmpty(strMsg)) {
            Tools.showToast(strMsg)
        }
    }


    private var imSignIcon: ImageView? = null
    private var isSpaceSign: Int = 0

    /**
     * 语音豆复购弹窗展示判断逻辑
     */
    private fun showVoiceBeanPay() {

        if (imSignIcon == null) {
            imSignIcon = findViewById<ImageView>(R.id.im_memberspace_sign_icon)
        }
        //语音豆复购弹窗
        val configInfo = YYApplication.getInstance().configInfo
        if (configInfo != null) {
            val otherCfg = configInfo.otherCfg
            if (otherCfg != null) {
                isSpaceSign = otherCfg.isSpaceSign
                if (isSpaceSign == 1) {
                    //判断用户是否签约
                    RequestApiData.getInstance().isHaveAgency(IsHaveAgencyResponse::class.java, this@IndividualitySpaceActivity)
                } else {
                    imSignIcon?.visibility = View.GONE
                }
            }
        }
    }

    /**
     * 展示未签约入口
     *
     * @return
     */
    private fun showUnsignedIcon() {
        imSignIcon?.visibility = View.VISIBLE
        imSignIcon?.setOnClickListener {
            UmsAgent.onCBtn(mContext, RazorConstants.UBT_MEMBERSPACE_GET_VIP)
            showWebViewDialogActivity2("/pay/getPaySigningPop.gy", "语音豆复购", Constants.WEBVIEW_FLAG_MEMBERSPACE)
        }
    }


    override fun onResume() {
        super.onResume()

        if (Tools.isBoy()) {
            if (YYApplication.getInstance().isRefreshPayStateMember == 1) {
                showVoiceBeanPay()
                YYApplication.getInstance().isRefreshPayStateMember = 0
            }
        }
    }

    private fun singleOutUser(isLike: Int) {
        val singleOutUserRequest = SingleOutUserRequest()
        singleOutUserRequest.isLike = isLike
        singleOutUserRequest.userId = mUser?.id
        RequestApiData.getInstance().singleOutUser(singleOutUserRequest, SingleOutUserResponse::class.java, object : NewHttpResponeCallBack {
            override fun onResponeStart(apiName: String) {}

            override fun onLoading(apiName: String, count: Long, current: Long) {}

            override fun onSuccess(apiName: String, `object`: Any) {
                if (isFinishing) {
                    return
                }
                if (`object` is SingleOutUserResponse) {
                    if (`object`.isMatching == 1) {
                        // 匹配成功
                        CustomDialog.getInstance(CustomDialog.DialogType.ZZ_MATCHING_SUCCEED, `object`.user).show(supportFragmentManager)

                    } else if (`object`.isInterception == 1) {
                        // 头像拦截
                        showNewUiInsertPictureDialog(R.layout.insert_picture_new_ui, InsertPictureDialog.InsertionPictureOnFinishListener { imagePath, bitmap ->
                            if (!StringUtils.isEmpty(imagePath)) {
                                val imageSuffix = FileUtils.getFileExtName(imagePath)
                                var `is`: InputStream? = null
                                try {
                                    `is` = FileInputStream(File(imagePath))
                                    uploadImg(UploadImgRequest(1, `is`, imageSuffix))
                                } catch (e: Exception) {
                                    e.printStackTrace()
                                } finally {
                                    if (`is` != null) {
                                        try {
                                            `is`.close()
                                        } catch (ex: Exception) {
                                            ex.printStackTrace()
                                        }

                                    }
                                }

                            }
                        }, "上传头像会有异性主动找你聊天哟~", InsertPictureDialog.InsertPictureOnCancelListener {
                            // 取消
                        })
                        return
                    } else if (`object`.isShowVoice == 1) {
                        // 语音通话
                        CustomDialog.getInstance(CustomDialog.DialogType.ZZ_HINT_VOICE_COMMUNICATE, mUser).show(supportFragmentManager)
                        return
                    }


                    if (!StringUtils.isEmpty(`object`.interceptUrl)) {
                        showWebViewDialogActivity2(`object`.interceptUrl, "语音豆复购", Constants.WEBVIEW_FLAG_YUANFEN)
                        return
                    }

                    val msg = `object`.msg
                    if (!StringUtils.isEmpty(msg)) {
                        // 展示提示语
                        Tools.showToastCenter(msg)
                    }
                    changeState()

                }
            }

            override fun onFailure(apiName: String, t: Throwable, errorNo: Int, strMsg: String) {
                if (isFinishing) {
                    return
                }
                Tools.showToast(strMsg)
                dismissLoadingDialog()
            }
        })
    }

    private fun changeState() {
        EventBusHelper.getDefault().post(UpdateEnterSceceBtnEvent(postion))
        id_space_date.background = resources.getDrawable(R.drawable.space_date_gray_bg_shape)
        id_space_date.isClickable = false
    }

    private fun uploadImg(uploadImgRequest: UploadImgRequest) {
        RequestApiData.getInstance().uploadImg(uploadImgRequest,
                UploadImgResponse::class.java, object : NewHttpResponeCallBack {
            override fun onResponeStart(apiName: String) {
                showLoadingDialog("正在上传头像...")
            }

            override fun onLoading(apiName: String, count: Long, current: Long) {

            }

            override fun onSuccess(apiName: String, `object`: Any) {
                if (isFinishing) {
                    return
                }
                // 上传相片
                val uploadInfo = `object` as UploadImgResponse
                if (uploadInfo.image != null) {
                    val image = uploadInfo.image
                    if (image != null) {
                        Tools.showToast("头像审核中，请耐心等待!")
                        YYPreferences.getInstance().headUrl = image.thumbnailUrl
                        val application = YYApplication.getInstance()
                        if (application.currentUser != null) {
                            application.currentUser.image = image
                        }
                    }
                }
                dismissLoadingDialog()
            }

            override fun onFailure(apiName: String, t: Throwable, errorNo: Int, strMsg: String) {
                if (isFinishing) {
                    return
                }
                Tools.showToast(strMsg)
                dismissLoadingDialog()
            }
        })
    }


    var mBaiduMap: BaiduMap? = null

    private fun initMap() {
        id_space_map.visibility = View.VISIBLE
        val mMapView = id_space_map
        mMapView.isClickable = true
        mMapView.showZoomControls(false)
        mMapView.showScaleControl(false)
        mBaiduMap = mMapView.map
        val msu = MapStatusUpdateFactory.zoomTo(17.0f)//16.0f(值越大越详细)
        mBaiduMap?.setMapStatus(msu)
        val uiSettings = mBaiduMap?.uiSettings
        uiSettings?.isOverlookingGesturesEnabled = false//屏蔽双指下拉时变成3D地图
        uiSettings?.isRotateGesturesEnabled = false//屏蔽旋转
        uiSettings?.isZoomGesturesEnabled = false//获取是否允许缩放手势返回:是否允许缩放手势
        uiSettings?.isCompassEnabled = true//隐藏缩放按钮
        uiSettings?.isScrollGesturesEnabled = false
        setMapLocation()
    }


    /**
     * Request permissions.
     */
    private fun requestPermission(vararg permissions: String) {
        val sdkVersion = this.applicationInfo.targetSdkVersion
        if (LogUtils.DEBUG) {
            LogUtils.w("授权sdkVersion＝$sdkVersion")
        }

        AndPermission.with(this)
                .runtime()
                .permission(*permissions)
                .rationale(RuntimeRationale())
                .onGranted { permissions ->
                    // 授权成功
                    if (LogUtils.DEBUG && permissions != null) {
                        LogUtils.w("授权成功＝", TextUtils.join("\n", permissions))
                    }
                    initMap()

                }
                .onDenied { permissions ->
                    // 授权失败
                    if (LogUtils.DEBUG && permissions != null) {
                        LogUtils.e("授权失败＝", TextUtils.join("\n", permissions))
                    }
                    id_space_map.visibility = View.GONE
                    if (sdkVersion >= 26) {

                    }
                }
                .start()
    }


}
