package com.app.ui.activity

import android.graphics.Color
import android.os.Bundle
import android.util.Log

import com.app.R
import com.app.api.InterfaceUrlConstants
import com.app.api.RequestApiData
import com.app.model.request.SetMatchInfoRequest
import com.app.model.response.SetMatchInfoResponse
import com.app.ui.YYBaseActivity
import com.app.util.Tools
import com.yy.ui.fragment.ActionBarFragment
import com.yy.util.net.NewHttpResponeCallBack
import com.yy.util.string.StringUtils
import kotlinx.android.synthetic.main.perfection_match_info_layout.*

class PerfectionMatchInfoActivity : YYBaseActivity(), NewHttpResponeCallBack {


    var individualityText: String = ""
    var oppositeText: String = ""
    var individualitydata: Array<String>? = null
    var oppositedata: Array<String>? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.perfection_match_info_layout)
        innitData()
        initView()
    }

    private fun innitData() {
        individualitydata = getIndividualityData()
        individualityText = individualitydata?.get(0) ?: ""
        oppositedata = getOppositeData()
        oppositeText = oppositedata?.get(0) ?: ""
    }

    private fun initView() {
        val fragment = supportFragmentManager.findFragmentById(R.id.id_actionbar_fragment) as ActionBarFragment
        fragment.setTitleName("完善匹配信息")
        initPickerView()

    }

    private fun initPickerView() {

        number_picker_1.refreshByNewDisplayedValues(individualitydata)
        number_picker_1.isFocusable = true
        number_picker_1.isFocusableInTouchMode = true
        number_picker_1.setOnValueChangedListener { picker, oldVal, newVal ->
            individualityText = individualitydata?.get(newVal) ?: ""

        }
        number_picker_1.post {
            number_picker_1.smoothScrollToValue(2)
        }

        number_picker_2.refreshByNewDisplayedValues(oppositedata)
        number_picker_2.isFocusable = true
        number_picker_2.isFocusableInTouchMode = true
        number_picker_2.setOnValueChangedListener { picker, oldVal, newVal ->
            oppositeText = oppositedata?.get(newVal) ?: ""
        }
        number_picker_2.post {
            number_picker_2.smoothScrollToValue(2)
        }

        id_matching_start.setOnClickListener {

            if (!StringUtils.isEmpty(individualityText) && !StringUtils.isEmpty(oppositeText)) {
                val setMatchInfoRequest = SetMatchInfoRequest()
                setMatchInfoRequest.individuality = individualityText
                setMatchInfoRequest.oppositeType = oppositeText
                RequestApiData.getInstance().setMatchInfo(setMatchInfoRequest, SetMatchInfoResponse::class.java, this)
            } else {
                Tools.showToast("选一个再去寻找吧")
            }
        }

    }

    override fun onResponeStart(apiName: String?) {
    }

    override fun onLoading(apiName: String?, count: Long, current: Long) {
    }

    override fun onSuccess(apiName: String?, `object`: Any?) {
        if (InterfaceUrlConstants.URL_SETMATCHINFO == apiName) {
            if (`object` is SetMatchInfoResponse) {
                if (`object`.isSucceed == 1) {
                    Tools.showToast(`object`.msg)
                    this.finish()
                }
            }
        }
    }

    override fun onFailure(apiName: String?, t: Throwable?, errorNo: Int, strMsg: String?) {
    }

    /**
     * 生成个性列表
     */
    private fun getIndividualityData(): Array<String>? {
        return if (Tools.isBoy()) resources.getStringArray(R.array.match_info_man) else resources.getStringArray(R.array.match_info_woman)
    }

    /**
     * 生成个性列表
     */
    private fun getOppositeData(): Array<String>? {
        return if (Tools.isBoy()) resources.getStringArray(R.array.match_info_woman) else resources.getStringArray(R.array.match_info_man)
    }


    override fun onDestroy() {
        super.onDestroy()
    }
}
