package com.app.ui.adapter

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.app.R
import com.app.YYApplication
import com.app.model.NearbyUser
import com.app.model.Yuanfen
import com.app.util.Tools
import com.bumptech.glide.Glide
import com.bumptech.glide.request.RequestOptions
import com.yy.util.string.StringUtils
import jp.wasabeef.glide.transformations.RoundedCornersTransformation
import java.util.*

class OnLinePersonFragmentAdapter(val context: Context?) : RecyclerView.Adapter<OnLinePersonFragmentAdapter.OnLinePersonFragmentViewHolder>() {

    private var mData: ArrayList<NearbyUser>? = null
//    private val defaultLeftBitmap = BitmapFactory.decodeResource(
//            YYApplication.getInstance().resources,
//            R.drawable.default_head)

    override fun onCreateViewHolder(viewGroup: ViewGroup, i: Int): OnLinePersonFragmentViewHolder {
        return OnLinePersonFragmentViewHolder(View.inflate(YYApplication.getInstance(), R.layout.online_person_item_layout, null))
    }

    override fun onBindViewHolder(onLinePersonFragmentViewHolder: OnLinePersonFragmentViewHolder, i: Int) {

        val yuanfen = mData!![i]
        if (yuanfen != null) {
            val userBase = yuanfen.userBase
            if (userBase != null) {
                val nickName = userBase.nickName
                val image = userBase.image
                if (!StringUtils.isEmpty(nickName)) {
                    onLinePersonFragmentViewHolder.userName.text = nickName
                }
                if (image != null) {
                    val imageUrl = image.imageUrl
                    if (context != null) {
                        Glide.with(context)
                                .load(imageUrl)
                                .apply(RequestOptions.placeholderOf(R.drawable.default_head)
                                        .transform(RoundedCornersTransformation(Tools.dp2px(10f), 0)))
                                .into(onLinePersonFragmentViewHolder.userPhoto)
                    }
                }
                if (!StringUtils.isEmpty(userBase.distance)) {
                    onLinePersonFragmentViewHolder.userDistance.visibility = View.VISIBLE
                    onLinePersonFragmentViewHolder.userDistance.text = String.format(YYApplication.getInstance().resources.getString(R.string.distance_text),userBase.distance)
                }else{
                    onLinePersonFragmentViewHolder.userDistance.visibility = View.GONE
                }
            }
        }
    }

    override fun getItemCount(): Int {
        return if (mData != null) mData!!.size else 0
    }

    fun setData(mUserDatas: ArrayList<NearbyUser>) {
        this.mData = mUserDatas
    }

    fun clearData() {
        if (mData != null) {
            mData!!.clear()
        }
    }


    inner class OnLinePersonFragmentViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {

        var userPhoto: ImageView
        var userName: TextView
        var userDistance:TextView

        init {
            userPhoto = itemView.findViewById(R.id.id_user_photo)
            userName = itemView.findViewById(R.id.id_user_name)
            userDistance = itemView.findViewById(R.id.id_user_distance)
        }
    }

}
