package com.app.ui.adapter

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView

import com.app.R
import com.app.YYApplication
import com.app.model.Image
import com.app.ui.adapter.viewholder.BaseViewHolder
import com.app.util.Tools
import com.yy.util.image.VolleyUtil
import com.yy.util.string.StringUtils

class SpacePhotoListAdapter : BaseRecyclerAdapter() {


    private var data: List<Image>? = null

    override fun getItemCount(): Int {
        return data?.size ?: 0
    }

    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        super.onBindViewHolder(holder, position)
        if (holder is SpacePhotoListHolder) {
            val mImage = data?.get(position)
            if (mImage != null) {
                val imageUrl = mImage.imageUrl
                if (!StringUtils.isEmpty(imageUrl)) {
                    YYApplication.getInstance().imageLoader.get(imageUrl,
                            VolleyUtil.getImageListener(holder.userPhoto, null, null),
                            holder.userPhoto.measuredWidth, holder.userPhoto.measuredHeight, true, Tools.dp2px(5f).toFloat())
                }
            }
        }

    }

    override fun onCreateViewHolder(viewGroup: ViewGroup, itemType: Int): RecyclerView.ViewHolder {

        return SpacePhotoListHolder(LayoutInflater.from(YYApplication.getInstance()).inflate(R.layout.space_photo_list_layout, viewGroup, false))
    }

    fun setData(listImage: List<Image>) {
        this.data = listImage
    }


    inner class SpacePhotoListHolder(itemView: View) : BaseViewHolder(itemView) {
        var userPhoto: ImageView = itemView.findViewById(R.id.id_user_photo)

    }
}
