package com.app.ui.adapter

import android.annotation.SuppressLint
import android.support.v4.app.Fragment
import android.support.v7.widget.RecyclerView
import android.text.TextUtils
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import com.app.R
import com.app.YYApplication
import com.app.model.Score
import com.app.ui.adapter.viewholder.BaseViewHolder
import com.bumptech.glide.Glide
import com.bumptech.glide.load.resource.drawable.DrawableTransitionOptions
import com.bumptech.glide.request.RequestOptions

/**
 * Created by liujiawei on 2017/7/18.
 */
class VideoPalAdapter(val fragment: Fragment, val datas: List<Score>) : BaseRecyclerAdapter() {

    var type = 0

    override fun getItemCount(): Int {
        return if (datas != null) datas.size else 0
    }

    @SuppressLint("SetTextI18n")
    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        super.onBindViewHolder(holder, position)

        val rose = datas[position]
        if (holder is VideoPalViewHolder) {


            if (type == 1) {
                holder.rose?.setImageDrawable(YYApplication.getInstance().resources.getDrawable(R.drawable.icon_my_space_charm_value))
            } else {
                holder.rose?.setImageDrawable(YYApplication.getInstance().resources.getDrawable(R.drawable.icon_my_space_rose))
            }

            if (!TextUtils.isEmpty(rose.userBase?.image?.imageUrl)) {

                Glide.with(fragment)
                        .load(rose.userBase.image.imageUrl)
                        .apply(RequestOptions.placeholderOf(R.drawable.male_user_default_icon))
                        .apply(RequestOptions.circleCropTransform())
                        .transition(DrawableTransitionOptions.withCrossFade())
                        .into(holder.headPortrait!!)
//                YYApplication.getInstance().imageLoader.get(rose.userBase.image.imageUrl,
//                        VolleyUtil.getImageListener(holder.headPortrait), holder.headPortrait!!.measuredWidth, holder.headPortrait!!.measuredWidth, true)
            }

            if (!TextUtils.isEmpty(rose.userBase.nickName)) {
                holder.name?.text = rose.userBase.nickName
            }

            if (!TextUtils.isEmpty(rose.time)) {
                holder.duration?.text = rose.time
            }

            holder.roseDes?.text = "+" + rose.count
        }

    }

    override fun onCreateViewHolder(viewGroup: ViewGroup, itemType: Int): RecyclerView.ViewHolder {
        val from = LayoutInflater.from(YYApplication.getInstance())
        return VideoPalViewHolder(from.inflate(R.layout.video_pal_item, viewGroup, false))
    }

    fun setMsgType(type: Int) {
        this.type = type
    }

    class VideoPalViewHolder(itemView: View?) : BaseViewHolder(itemView) {

        var headPortrait: ImageView? = null
        var name: TextView? = null
        var duration: TextView? = null
        var roseDes: TextView? = null
        var rose: ImageView? = null

        init {
            headPortrait = itemView?.findViewById(R.id.id_head_portrait)
            name = itemView?.findViewById(R.id.id_user_name)
            duration = itemView?.findViewById(R.id.id_duration)
            roseDes = itemView?.findViewById(R.id.id_rose_des)
            rose = itemView?.findViewById(R.id.id_rose)
        }
    }

}