package com.app.ui.fragment

import android.graphics.Color
import android.os.Bundle
import android.support.v4.view.ViewPager
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.app.R
import com.app.YYApplication
import com.app.ui.adapter.OnLineTabFragmentAdapter
import com.app.util.Tools
import com.app.widget.indicator.TabPageIndicator
import com.yy.ui.fragment.MyFragment
import java.util.*


/**
 * 在线
 */

class OnLineTabFragment : BaseHomeFragment() {

    private var mRootView: View? = null
    private var statusbarPlaceholderView: View? = null
    private var mPager: ViewPager? = null
    private var mIndicator: TabPageIndicator? = null
    private val mTabFragments = ArrayList<MyFragment>()
    private val mTabContents = ArrayList<String>()
    private var mAdapter: OnLineTabFragmentAdapter? = null


    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        mRootView =  inflater.inflate(R.layout.online_tab_fragment_layout, container ,false)
        initData()
        initView()
        return mRootView
    }


    private fun initView() {
        statusbarPlaceholderView = mRootView!!.findViewById(R.id.view_statusbar_placeholder)
        mAdapter = OnLineTabFragmentAdapter(childFragmentManager)
        mAdapter!!.setData(mTabContents, mTabFragments)

        mPager = mRootView!!.findViewById(R.id.pager)
        mPager!!.adapter = mAdapter

        mIndicator = mRootView!!.findViewById(R.id.indicator)
        mIndicator!!.visibility = View.VISIBLE
        mIndicator!!.setViewPager(mPager)

    }

    private fun initData() {

        if (YYApplication.getInstance().configInfo != null) {
            if (YYApplication.getInstance().configInfo.otherCfg != null) {
                if (Tools.isBoy() && YYApplication.getInstance().isShowVideoDating == 1) {
                    mTabFragments.add(OnLineVoiceFragment())
                    mTabContents.add("附近语音")
                }
            }
        }

        mTabContents.add("附近的人")
        mTabFragments.add(OnLinePersonFragment())
    }

    override fun updateTopBarPadding(isSupportDarkTintMode: Boolean, isSupportTintMode: Boolean) {
        if (activity == null) {
            return
        }
        if (isSupportDarkTintMode) {
            showTopPlaceHolderView(statusbarPlaceholderView, Color.WHITE)
        } else if (isSupportTintMode) {
            showTopPlaceHolderView(statusbarPlaceholderView, Color.BLACK)
        }
    }
}
