package com.app.ui.fragment

import android.graphics.Rect
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup

import com.app.R
import com.app.YYApplication
import com.app.api.InterfaceUrlConstants
import com.app.api.RequestApiData
import com.app.model.VideoGirlUser
import com.app.model.Yuanfen
import com.app.model.response.GetVideoGirlUserResponse
import com.app.ui.activity.HomeActivity
import com.app.ui.adapter.OnLineVoiceFragmentAdapter
import com.app.util.Tools
import com.github.jdsjlzx.recyclerview.LRecyclerView
import com.github.jdsjlzx.recyclerview.LRecyclerViewAdapter
import com.github.jdsjlzx.recyclerview.ProgressStyle
import com.yy.ui.fragment.MyFragment
import com.yy.util.net.NewHttpResponeCallBack
import com.yy.util.string.StringUtils
import java.util.ArrayList

class OnLineVoiceFragment : MyFragment(), NewHttpResponeCallBack {


    // 加载网络页数
    private var loadPageNum = 0
    private var mRootView: View? = null
    private var mVoiceListView: LRecyclerView? = null
    private var mOnLineVoiceFragmentAdapter: OnLineVoiceFragmentAdapter? = null
    private var mLRecyclerViewAdapter: LRecyclerViewAdapter? = null
    private val mVoiceDatas = ArrayList<VideoGirlUser>()

    override fun onVisible(isInit: Boolean) {
        if (isInit) {

        }
    }


    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        return inflater.inflate(R.layout.online_voice_fragment_layout, null)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        mRootView = view
        initView()
    }

    private fun initView() {

        mVoiceListView = mRootView!!.findViewById(R.id.id_voice_list)
        mVoiceListView!!.setRefreshProgressStyle(ProgressStyle.BallPulseSync)
        mVoiceListView!!.setLoadingMoreProgressStyle(ProgressStyle.BallPulse)
        mVoiceListView!!.layoutManager = LinearLayoutManager(YYApplication.getInstance(), LinearLayoutManager.VERTICAL, false)
        mOnLineVoiceFragmentAdapter = OnLineVoiceFragmentAdapter(activity as HomeActivity, fragmentManager)
        mOnLineVoiceFragmentAdapter?.setData(mVoiceDatas)
        mLRecyclerViewAdapter = LRecyclerViewAdapter(mOnLineVoiceFragmentAdapter)
        mVoiceListView!!.adapter = mLRecyclerViewAdapter

        mVoiceListView!!.addItemDecoration(object : RecyclerView.ItemDecoration() {
            override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State?) {
                super.getItemOffsets(outRect, view, parent, state)
                if (parent.getChildPosition(view) > 0) {
                    outRect.top = Tools.dp2px(12f)
                }
            }
        })

        mVoiceListView!!.setOnRefreshListener {
            loadPageNum = 0
            mOnLineVoiceFragmentAdapter!!.clearData()
            mLRecyclerViewAdapter!!.notifyDataSetChanged()
            loadVoiceData()
        }

        mVoiceListView!!.setOnLoadMoreListener {
            loadVoiceData()
        }

        mVoiceListView!!.setOnNetWorkErrorListener {

        }

        mVoiceListView!!.forceToRefresh()
    }

    private fun loadVoiceData() {
        if (loadPageNum > 2) {
            Tools.showToast("没有更多数据了ಥ_ಥ")
            mVoiceListView!!.refreshComplete(loadPageNum)
        } else {
            RequestApiData.getInstance().getVideoGirlUser(GetVideoGirlUserResponse::class.java, this)
        }

    }

    override fun onDestroyView() {
        super.onDestroyView()
    }

    override fun onResponeStart(apiName: String?) {
    }

    override fun onLoading(apiName: String?, count: Long, current: Long) {
    }

    override fun onSuccess(apiName: String?, `object`: Any?) {

        if (InterfaceUrlConstants.URL_GETVIDEOGIRLUSER == apiName && `object` is GetVideoGirlUserResponse) {
            val listUser = `object`.listUser
            if (listUser.size > 0) {
                loadPageNum += 1
                mVoiceDatas.addAll(listUser)
            } else {
                Tools.showToast("暂时没有人呦")
            }

            mLRecyclerViewAdapter?.notifyDataSetChanged()
            mVoiceListView!!.refreshComplete(loadPageNum)
        }
    }

    override fun onFailure(apiName: String?, t: Throwable?, errorNo: Int, strMsg: String?) {
        if (InterfaceUrlConstants.URL_GETVIDEOGIRLUSER == apiName) {
            Tools.showToast(strMsg)
            mLRecyclerViewAdapter?.notifyDataSetChanged()
            mVoiceListView!!.refreshComplete(loadPageNum)
        }
    }
}
