package com.app.ui.fragment

import android.app.Activity
import android.graphics.Rect
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.app.R
import com.app.YYApplication
import com.app.api.RequestApiData
import com.app.constants.KeyConstants
import com.app.model.request.GetScoreRequest
import com.app.model.response.GetScoreResponse
import com.app.ui.activity.VideoPalActivity
import com.app.ui.adapter.VideoPalAdapter
import com.app.util.Tools
import com.app.widget.HotFixRecyclerView
import com.yy.ui.fragment.ActionBarFragment
import com.yy.ui.fragment.MyFragment
import com.yy.util.net.NewHttpResponeCallBack
import kotlinx.android.synthetic.main.fragment_video_pal.*

/**
 * Created by liujiawei on 15/09/2017.
 *
 * 玫瑰积分、魅力值列表页
 */
@Suppress("DEPRECATED_IDENTITY_EQUALS")
class VideoPalFragment : MyFragment(), NewHttpResponeCallBack {

    var rootView: View? = null
    var mContent: VideoPalActivity? = null
    var testView: TextView? = null
    var actionBarFragment: ActionBarFragment? = null

    fun newInstance(): VideoPalFragment {
        val args = Bundle()
        val fragment = VideoPalFragment()
        fragment.arguments = args
        return fragment
    }

    override fun onAttach(activity: Activity?) {
        super.onAttach(activity)
        mContent = activity as VideoPalActivity?
    }

    override fun onVisible(isInit: Boolean) {
        if (!isInit) {
            initData()
        }
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        rootView = inflater.inflate(R.layout.fragment_video_pal, container, false)
        initView()
        initData()
        return rootView
    }


    private fun initView() {
//        decView = rootView?.findViewById(R.id.id_dec_bg)
        testView = rootView?.findViewById(R.id.id_test)
        actionBarFragment = childFragmentManager.findFragmentById(R.id.action_bar_fragment) as ActionBarFragment?
        actionBarFragment?.setLeftBtnImage(R.drawable.btn_back_selector) {
            mContent?.finish()
        }
        rootView?.findViewById<TextView>(R.id.btn_extracty)?.setOnClickListener {
            // 提现
            mContent?.showVideoGirlExtractyActivity()
        }

//        rootView?.findViewById<TextView>(R.id.id_protocol)?.setOnClickListener {
//            val config = YYApplication.getInstance().configInfo
//            if (config != null) {
//                val cfg = config.otherCfg
//                if (cfg != null) {
//                    val protocalUrl = cfg.redPacketProtocolUrl
//                    mContent?.showWebViewActivity(protocalUrl, "使用协议")
//                }
//            }
//        }

        val id_list = rootView?.findViewById<HotFixRecyclerView>(R.id.id_list) as RecyclerView
        id_list.layoutManager = LinearLayoutManager(YYApplication.getInstance())
        id_list.addItemDecoration(object : RecyclerView.ItemDecoration() {
            override fun getItemOffsets(outRect: Rect, view: View, parent: RecyclerView, state: RecyclerView.State?) {
                super.getItemOffsets(outRect, view, parent, state)
                if (parent.getChildPosition(view) !== 0) {
                    outRect.top = Tools.dp2px(0.66f)
                }
            }
        })
    }

    private fun initData() {
        var type = 0
        if (arguments != null) {
            type = arguments!!.getInt(KeyConstants.KEY_TYPE)
        }

        if (type == 0) {
            testView?.text = "得到的玫瑰"
            actionBarFragment?.setTitleName("玫瑰积分")
        } else {
            testView?.text = "得到的魅力值"
            actionBarFragment?.setTitleName("魅力值")
        }

        RequestApiData.getInstance().getScore(GetScoreRequest(type), GetScoreResponse::class.java, this)
    }

    override fun onResponeStart(apiName: String?) {
        mContent?.showLoadingDialog("正在加载...")
    }

    override fun onLoading(apiName: String?, count: Long, current: Long) {
    }

    override fun onSuccess(apiName: String?, `object`: Any?) {
        mContent?.dismissLoadingDialog()
        if (`object` is GetScoreResponse) {
            bindingData(`object`)
        }
    }

    private fun bindingData(data: GetScoreResponse) {
        if (id_red_rose_count != null) {
            id_red_rose_count.text = data.totalScore
        }

        if (data.listScore != null && data.listScore.size > 0) {
            testView?.visibility = View.VISIBLE
            val adapter = VideoPalAdapter(this, data.listScore)
            adapter.setMsgType(data.type)
            if (id_list != null) {
                id_list.adapter = adapter
                id_list.adapter.notifyDataSetChanged()
            }
        }

    }

    override fun onFailure(apiName: String?, t: Throwable?, errorNo: Int, strMsg: String?) {
        mContent?.dismissLoadingDialog()

    }
}
